package ru.akimov.timerbug.ejb.impl;

import ru.akimov.timerbug.ejb.TimerFactory;

import javax.ejb.*;
import java.rmi.RemoteException;
import java.text.MessageFormat;
import java.util.logging.Logger;

/**
 * TimerFactoryEJb implementation.
 *
 * Created by IntelliJ IDEA.
 * User: akimov
 * Date: 08.03.12
 * Time: 11:15
 * To change this template use File | Settings | File Templates.
 */
public class TimerFactoryBean implements TimerFactory, SessionBean, TimedObject {
    private static final Logger LOGGER = Logger.getLogger(TimerFactoryBean.class.getName());
    private SessionContext context;

    @Override
    public void ejbTimeout(Timer timer) {
        LOGGER.info(MessageFormat.format("Timer ''{0}'' has expired", timer.getInfo()));
    }

    @Override
    public void createTimer() {
        ScheduleExpression expression = new ScheduleExpression().second("*/10").minute("*").hour("*");
        TimerConfig config = new TimerConfig("Programmatically created timer", false);
        context.getTimerService().createCalendarTimer(expression, config);
    }

    @Override
    public void setSessionContext(SessionContext context) throws EJBException, RemoteException {
        this.context = context;
    }

    @Override
    public void ejbRemove() throws EJBException, RemoteException {
        //nothing to do
    }

    @Override
    public void ejbActivate() throws EJBException, RemoteException {
        //nothing to do
    }

    @Override
    public void ejbPassivate() throws EJBException, RemoteException {
        //nothing to do
    }
}
