package ru.akimov.timerbug.web;

import ru.akimov.timerbug.ejb.TimerFactory;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.Writer;

/**
 * Servlet to invoke {@link ru.akimov.timerbug.ejb.TimerFactory}.
 * 
 * Created by IntelliJ IDEA.
 * User: akimov
 * Date: 08.03.12
 * Time: 11:22
 * To change this template use File | Settings | File Templates.
 */
public class TimerFactoryServlet extends HttpServlet {
    private TimerFactory factory;

    @Override
    public void init() throws ServletException {
        try
        {
            Context context = new InitialContext();
            try {
                factory = (TimerFactory) context.lookup("java:comp/env/ejb/TimerFactory");
            }
            finally {
                context.close();
            }
        }
        catch (NamingException e)
        {
            throw new ServletException("Failed to get timer factory", e);
        }
    }

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        factory.createTimer();
        Writer writer = response.getWriter();
        writer.write("Timer has been created successfully");
        writer.close();
    }
}
